local toc, privateData = ...
local AddonId = toc.identifier

EM.UI.Send = {}

EM.Event.Trigger.SendAttach, EM.Event.SendAttach = Utility.Event.Create(AddonId, "SendAttach")
EM.Event.Trigger.SendMessage, EM.Event.SendMessage = Utility.Event.Create(AddonId, "SendMessage")
EM.Event.Trigger.SendMultiRecipients, EM.Event.SendMultiRecipients = Utility.Event.Create(AddonId, "SendMultiRecipients")

function EM.UI.SetupSendTab()

	local sendTab = EM.UI.Send:getElement()
	local plat,gold,silver = EM.Utility.Coin(Inspect.Currency.List().coin)
	EM.UI.Send.Attachments = {}

	sendTab.Display = NK.CreateFrame('nkExtTexture', 'SendDisplay', sendTab,
		{	type = 'EasyMail', path = 'gfx/sendTabSmall.png', layer = 0,
			anchors = {	{ from = 'TOPLEFT', object = sendTab, to = 'TOPLEFT' },
						{ from = 'BOTTOMRIGHT', object = sendTab, to = 'BOTTOMRIGHT' }}
		})
	
	sendDisplay = sendTab.Display:getElement()
	
	sendTab.ToField = NK.CreateFrame('nkExtTextField', 'SendTo', sendDisplay,
		{	height = 19, width = 332, label = 'TO', labelwidth = 25, fontsize = 13,
			visible = true, value = '', layer = 5,
			color =	{ border = 'FFFFFF', body = '000000', label = 'FFFFFF', alphaborder = 0, alphabody = 0 },
			anchors ={{ from = 'TOPLEFT', object = sendTab, to = 'TOPLEFT', x = 17, y = 8 }},
			func = function(value) end
		})
	
	sendTab.btnContacts = UI.CreateFrame("Texture", "ContactsBtn", sendTab)
		sendTab.btnContacts:SetTexture("Rift", "btn_LFG_Quest_(normal).pn.png.dds")
		sendTab.btnContacts:SetPoint("TOPLEFT", sendTab.ToField:getElement(), "TOPRIGHT", 0, -8)
		sendTab.btnContacts:SetHeight(32)
		sendTab.btnContacts:SetWidth(32)
		sendTab.btnContacts:SetLayer(5)
		sendTab.btnContacts.Event.MouseIn = function() 
			sendTab.btnContacts:SetTexture("Rift", "btn_LFG_Quest_(over).pn.png.dds")
		end
		sendTab.btnContacts.Event.MouseOut = function() 
			sendTab.btnContacts:SetTexture("Rift", "btn_LFG_Quest_(normal).pn.png.dds")
		end
		sendTab.btnContacts.Event.LeftDown = function() 
			sendTab.btnContacts:SetTexture("Rift", "btn_LFG_Quest_(click).pn.png.dds")
		end
		sendTab.btnContacts.Event.LeftUp = function() 
			sendTab.btnContacts:SetTexture("Rift", "btn_LFG_Quest_(normal).pn.png.dds")
			if not EM.UI.ContactsWindow then
				EM.UI.Contacts.Create()
			elseif EM.UI.ContactsWindow and EM.UI.ContactsWindow:GetVisible() then
				EM.UI.ContactsWindow:SetVisible(false)
			else
				EM.UI.ContactsWindow:SetVisible(true)
			end
		end
		
	sendTab.SubjectField = NK.CreateFrame('nkExtTextField', 'SendSubject', sendDisplay,
		{	height = 19, width = 320, label = 'SUBJECT', labelwidth = 60, fontsize = 13,
			visible = true, value = '', layer = 5,
			color =	{ border = 'FFFFFF', body = '000000', label = 'FFFFFF', alphaborder = 0, alphabody = 0 },
			anchors ={{ from = 'TOPLEFT', object = sendTab.ToField:getElement(), to = 'BOTTOMLEFT', x = -31, y = 11 }},
			func = function(value) end
		})
		
	sendTab.MessageField = UI.CreateFrame("SimpleTextArea", "SendMessage", sendDisplay)
		sendTab.MessageField:SetBorder(1,1,1,1,0)
		sendTab.MessageField:SetBackgroundColor(0,0,0,0)
		sendTab.MessageField:SetWidth(387)
		sendTab.MessageField:SetHeight(179)
		sendTab.MessageField:SetLayer(5)
		sendTab.MessageField:SetText("")
		sendTab.MessageField:SetPoint("TOPLEFT", sendTab.SubjectField:getElement(), "BOTTOMLEFT", -67, 16)
			sendTab.MessageField.scroller.scrollbar:SetPoint("TOPLEFT", sendTab.MessageField.scroller, "TOPRIGHT", 7, 0)
			sendTab.MessageField.scroller.scrollbar:SetPoint("BOTTOMLEFT", sendTab.MessageField.scroller, "BOTTOMRIGHT", 7, 0)
			sendTab.MessageField.scroller.scrollbar:SetWidth(15)
			
	sendTab.AttachGrid = NK.CreateFrame('nkExtGrid', 'SendAttachGrid', sendDisplay,
		{	fontsize = 17, wheelFunc = function(counter) sendTab.AttachScrollBar:SetPosition(counter) end,
			headerfontsize = 15, layer = 5,
			color = {	headerBody = '', headerLabel = 'ECE4BD', 
						label = 'FFFFFF', border = '000000', body = '222222', 
						bodyhighlight = 'FFFFFF', labelhighlight = '000000' },
			anchors = {	{ from = 'CENTER', object = sendTab, to = 'CENTER', x = 0, y = 65 }}
		})
		
		local cols = {	{	align = 'center', header = 'Attachments:', texture = true, type = 'Rift', path = '',
							width = 25, textureWidth = 23, textureHeight = 23 },
						{	align = 'left', header = 'Item', width = 291 },
						{	align = 'left', header = 'Amount', width = 30 }}
		
		sendTab.AttachGrid:layout( cols, 4, {headerHeight = 27})
	
	sendTab.AttachScrollBar = UI.CreateFrame("RiftScrollbar", "inboxScrollBar", sendTab.AttachGrid:getElement(false))
		sendTab.AttachScrollBar:SetOrientation("vertical")
		sendTab.AttachScrollBar:SetPoint("TOPLEFT", sendTab.AttachGrid:getElement(false), "TOPRIGHT", 6, 26)
		sendTab.AttachScrollBar:SetLayer(5)
		sendTab.AttachScrollBar:SetHeight(97)
		sendTab.AttachScrollBar:SetWidth(15)
		sendTab.AttachScrollBar:SetRange(1, 1)
		sendTab.AttachScrollBar:SetEnabled(true)
		sendTab.AttachScrollBar:SetVisible(false)
		sendTab.AttachScrollBar.Event.ScrollbarChange = function()
			if sendTab.AttachScrollBar:GetVisible() then
				local pos = sendTab.AttachScrollBar:GetPosition()
				sendTab.AttachGrid:setPos(math.floor(pos))
			end
		end
		
	sendTab.Attach = UI.CreateFrame("Frame", "SendAttach", sendDisplay)
		sendTab.Attach:SetBackgroundColor(0,0,0,0)
		sendTab.Attach:SetLayer(10)
		sendTab.Attach:SetMouseMasking("limited")
		sendTab.Attach:SetPoint("TOPLEFT", sendTab.AttachGrid:getElement(false), "TOPLEFT")
		sendTab.Attach:SetPoint("BOTTOMRIGHT", sendTab.AttachGrid:getElement(false), "BOTTOMRIGHT")
		sendTab.Attach.Event.MouseIn = function()
			local held,id = Inspect.Cursor()
			if not held then return end
			if #EM.UI.Send.Attachments > 0 then
				for slot,data in pairs(EM.UI.Send.Attachments) do
					if data[1].key == id then 
						held = ""
					end
				end
			end
			if held == "item" then
				local item = Inspect.Item.Detail(id)
				if item.bound == nil then
					table.insert(EM.UI.Send.Attachments, { { key = id, value = item.icon }, { value = item.name, color = 'FFFFFF' }, { value = (item.stack or 1), color = 'FFFFFF' } })
				elseif item.bind == "account" then
					table.insert(EM.UI.Send.Attachments, { { key = id, value = item.icon }, { value = item.name, color = 'FFFFFF' }, { value = (item.stack or 1), color = 'FFFFFF' } })
				end
			end
		end
		sendTab.Attach.Event.MouseOut = function()
			local held,id = Inspect.Cursor()
			if not held then return end
			if held == "item" then
				table.remove(EM.UI.Send.Attachments, #EM.UI.Send.Attachments)
			end
		end
		sendTab.Attach.Event.LeftUp = function()
			Command.Cursor(nil)
			if #EM.UI.Send.Attachments == 0 then return end
			sendTab.AttachGrid.counter = sendTab.AttachGrid.counter or 1
			sendTab.AttachGrid:fill(EM.UI.Send.Attachments)
			if #EM.UI.Send.Attachments > 4 then
				sendTab.AttachScrollBar:SetRange(1, (#EM.UI.Send.Attachments-3))
				sendTab.AttachScrollBar:SetVisible(true)
			else
				sendTab.AttachScrollBar:SetVisible(false)
			end
			local coin = 0
			coin = (#EM.UI.Send.Attachments * 50) + (math.ceil(#EM.UI.Send.Attachments/6) * 25)
			local plat,gold,silver = EM.Utility.Coin(coin)
			sendTab.CostSilver:update({text = silver})
			if tonumber(gold) > 0 then 
				sendTab.CostGold:update({text = tonumber(gold)})
				sendTab.CostGold:SetVisible(true)
				sendTab.CostGoldIcon:SetVisible(true)
			else
				sendTab.CostGold:SetVisible(false)
				sendTab.CostGoldIcon:SetVisible(false)
			end
			if tonumber(plat) > 0 then
				sendTab.CostPlat:update({text = tonumber(plat)})
				sendTab.CostPlat:SetVisible(true)
				sendTab.CostPlatIcon:SetVisible(true)
			else
				sendTab.CostPlat:SetVisible(false)
				sendTab.CostPlatIcon:SetVisible(false)
			end
			if not sendTab.SubjectField:getValue(true) then
				sendTab.SubjectField:setValue(EM.UI.Send.Attachments[1][2].value .. " x" .. EM.UI.Send.Attachments[1][3].value)
				if (sendTab.ToField.element.textfield:GetText() ~= (nil or "")) and (sendTab.SubjectField.element.textfield:GetText() ~= (nil or "")) then
					sendTab.btnSend:SetEnabled(true)
				else
					sendTab.btnSend:SetEnabled(false)
				end
			end
		end
		
	sendTab.CostText = NK.CreateFrame('nkExtText', 'SendCost', sendDisplay,
		{	fontsize = 12, text = 'Postage Cost', height = 20, width = 80,
			color = 'FFFFFF', wordwrap = false, visible = true,
			anchors = {{ from = 'TOPLEFT', object = sendTab.AttachGrid:getElement(), to = 'BOTTOMLEFT', x = -19, y = 12 }}
		})
		
	sendTab.CostSilver = NK.CreateFrame('nkExtText', 'SendCostSilver', sendDisplay,
		{	fontsize = 14, text = '25', height = 15, width = 20,
			color = 'FFFFFF', wordwrap = false, visible = true,
			anchors = {{ from = 'TOPRIGHT', object = sendTab.CostText:getElement(), to = 'BOTTOMRIGHT', x = 64, y = -1 }}
		})
	
	sendTab.CostGoldIcon = NK.CreateFrame('nkExtTexture', 'SendCostGoldIcon', sendDisplay,
		{	type = 'EasyMail', path = 'gfx/gold.png',
			width = 16, height = 16, visible = false,
			anchors = {	{ from = 'TOPRIGHT', object = sendTab.CostSilver:getElement(), to = 'TOPLEFT', x = -2, y = 3 }}
		})
		
	sendTab.CostGold = NK.CreateFrame('nkExtText', 'SendCostGold', sendDisplay,
		{	fontsize = 14, text = '', height = 15, width = 20,
			color = 'FFFFFF', wordwrap = false, visible = false,
			anchors = {{ from = 'TOPRIGHT', object = sendTab.CostGoldIcon:getElement(), to = 'TOPLEFT', x = -2, y = -3 }}
		})
	
	sendTab.CostPlatIcon = NK.CreateFrame('nkExtTexture', 'SendCostPlatIcon', sendDisplay,
		{	type = 'EasyMail', path = 'gfx/platinum.png',
			width = 16, height = 16, visible = false,
			anchors = {{ from = 'TOPRIGHT', object = sendTab.CostGold:getElement(), to = 'TOPLEFT', x = -3, y = 3 }}
		})
		
	sendTab.CostPlat = NK.CreateFrame('nkExtText', 'SendCostPlat', sendDisplay,
		{	fontsize = 14, text = '', height = 15, width = 20,
			color = 'FFFFFF', wordwrap = false, visible = false,
			anchors = {{ from = 'TOPRIGHT', object = sendTab.CostPlatIcon:getElement(), to = 'TOPLEFT', x = -3, y = -3 }}
		})
		
	sendTab.YourMoneyText = NK.CreateFrame('nkExtText', 'SendYourMoney', sendDisplay,
		{	fontsize = 12, text = 'Your Money', height = 20, width = 80,
			color = 'FFFFFF', wordwrap = false, visible = true,
			anchors = {{ from = 'BOTTOMLEFT', object = sendTab.CostText:getElement(), to = 'BOTTOMLEFT', x = 0, y = 40 }}
		})
		
	sendTab.YourMoneySilver = NK.CreateFrame('nkExtText', 'SendYourMoneySilver', sendDisplay,
		{	fontsize = 14, text = silver, height = 15, width = 20,
			color = 'FFFFFF', wordwrap = false, visible = true,
			anchors = {{ from = 'TOPRIGHT', object = sendTab.CostSilver:getElement(), to = 'TOPRIGHT', x = 0, y = 40 }}
		})
		
	sendTab.YourMoneyGold = NK.CreateFrame('nkExtText', 'SendYourMoneyGold', sendDisplay,
		{	fontsize = 14, text = gold, height = 15, width = 20,
			color = 'FFFFFF', wordwrap = false, visible = true,
			anchors = {{ from = 'TOPRIGHT', object = sendTab.CostGold:getElement(), to = 'TOPRIGHT', x = 0, y = 40 }}
		})
		
	sendTab.YourMoneyPlat = NK.CreateFrame('nkExtText', 'SendYourMoneyGold', sendDisplay,
		{	fontsize = 14, text = plat,
			color = 'FFFFFF', wordwrap = false, visible = true,
			anchors = {{ from = 'TOPRIGHT', object = sendTab.CostPlat:getElement(), to = 'TOPRIGHT', x = 2, y = 40 }}
		})
		
	sendTab.SentMoneyText = NK.CreateFrame('nkExtText', 'SendSentMoney', sendDisplay,
		{	fontsize = 12, text = 'Amount to Send', height = 20, width = 80,
			color = 'FFFFFF', wordwrap = false, visible = true,
			anchors = {{ from = 'BOTTOMLEFT', object = sendTab.YourMoneyText:getElement(), to = 'BOTTOMLEFT', x = 208, y = 0 }}
		})
		
	sendTab.SentMoneySilver = NK.CreateFrame('nkExtTextField', 'SendSentMoneySilver', sendDisplay,
		{	value = '', valuetype = 'number', visible = true, height = 19, width = 20,
			color =	{ border = 'FFFFFF', body = '000000', alphaborder = 0, alphabody = 0 },
			anchors = {{ from = 'TOPRIGHT', object = sendTab.YourMoneySilver:getElement(), to = 'TOPRIGHT', x = 208, y = 1 }},
			func = function(value)
				if not sendTab.SubjectField:getValue(true) then
					sendTab.SubjectField:setValue((sendTab.SentMoneyPlat:getValue(true) or 0) .. " platinum " .. (sendTab.SentMoneyGold:getValue(true) or 0) .. " gold " .. (sendTab.SentMoneySilver:getValue(true) or 0) .. " silver")
				end
			end
		})

	sendTab.SentMoneyGold = NK.CreateFrame('nkExtTextField', 'SendSentMoneyGold', sendDisplay,
		{	value = '', valuetype = 'number', visible = true, height = 19, width = 20,
			color =	{ border = 'FFFFFF', body = '000000', alphaborder = 0, alphabody = 0 },
			anchors = {{ from = 'TOPRIGHT', object = sendTab.YourMoneyGold:getElement(), to = 'TOPRIGHT', x = 208, y = 1 }},
			func = function(value)
				if not sendTab.SubjectField:getValue(true) then
					sendTab.SubjectField:setValue((sendTab.SentMoneyPlat:getValue(true) or 0) .. " platinum " .. (sendTab.SentMoneyGold:getValue(true) or 0) .. " gold " .. (sendTab.SentMoneySilver:getValue(true) or 0) .. " silver")
				end
			end
		})

	sendTab.SentMoneyPlat = NK.CreateFrame('nkExtTextField', 'SendSentMoneyGold', sendDisplay,
		{	value = '', valuetype = 'number', visible = true, height = 19, width = 65,
			color =	{ border = 'FFFFFF', body = '000000', alphaborder = 0, alphabody = 0 },
			anchors = {{ from = 'TOPRIGHT', object = sendTab.YourMoneyPlat:getElement(), to = 'TOPRIGHT', x = 208, y = 1 }},
			func = function(value)
				if not sendTab.SubjectField:getValue(true) then
					sendTab.SubjectField:setValue((sendTab.SentMoneyPlat:getValue(true) or 0) .. " platinum " .. (sendTab.SentMoneyGold:getValue(true) or 0) .. " gold " .. (sendTab.SentMoneySilver:getValue(true) or 0) .. " silver")
				end
			end
		})
	
	sendTab.radioButtonGroup = Library.LibSimpleWidgets.RadioButtonGroup("RadioButtonGroup")
		sendTab.radioButtonGroup.Event.RadioButtonChange = function(self) end
		
	sendTab.SendMoneyRadio = UI.CreateFrame("SimpleRadioButton", "SendMoneyRadio", sendDisplay)
		sendTab.SendMoneyRadio:SetText("Send Money")
		sendTab.SendMoneyRadio:SetPoint("BOTTOMLEFT", sendTab.SentMoneyText:getElement(), "TOPLEFT", 0, -3)
		sendTab.SendMoneyRadio:SetSelected(true, true)
		sendTab.SendMoneyRadio.Event.RadioButtonSelect = function(self)
			sendTab.SentMoneySilver.element.textfield:SetText("")
			sendTab.SentMoneyGold.element.textfield:SetText("")
			sendTab.SentMoneyPlat.element.textfield:SetText("")
		end
		
	sendTab.CoDRadio = UI.CreateFrame("SimpleRadioButton", "SendCoDRadio", sendDisplay)
		sendTab.CoDRadio:SetText("C.O.D.")
		sendTab.CoDRadio:SetPoint("TOPLEFT", sendTab.SendMoneyRadio, "TOPRIGHT", 15, 0)
		sendTab.CoDRadio:SetEnabled(true)
		sendTab.CoDRadio.Event.RadioButtonSelect = function(self)
			sendTab.SentMoneySilver.element.textfield:SetText("")
			sendTab.SentMoneyGold.element.textfield:SetText("")
			sendTab.SentMoneyPlat.element.textfield:SetText("")
			EM.UI.Popup(1, "Only 6 attachments are allowed for C.O.D. mail")
			if #EM.UI.Send.Attachments == 0 then return end
			if #EM.UI.Send.Attachments > 6 then
				local attachments = {}
				for idx = 1,6,1 do
					table.insert(attachments, EM.UI.Send.Attachments[idx])
				end
				EM.UI.Send.Attachments = attachments
				EM.UI.Send.element.AttachGrid.counter = 1
				EM.UI.Send.element.AttachScrollBar:SetPosition(1)
				EM.UI.Send.element.AttachScrollBar:SetRange(1, 3)
				EM.UI.Send.element.AttachGrid:fill(EM.UI.Send.Attachments)
			end
		end
		
	sendTab.radioButtonGroup:AddRadioButton(sendTab.SendMoneyRadio)
	sendTab.radioButtonGroup:AddRadioButton(sendTab.CoDRadio)
	
	sendTab.btnSend = UI.CreateFrame("RiftButton", "Sendbtn", sendTab)
		sendTab.btnSend:SetText("Send")
		sendTab.btnSend:SetPoint("BOTTOMCENTER", sendTab, "BOTTOMCENTER", 0, 2)
		sendTab.btnSend:SetEnabled(false)
		sendTab.btnSend:SetLayer(25)
		
	function sendTab.ToField.element.textfield.Event:KeyDown(key)
		local code = string.byte(key)
		if tonumber(code) == 9 and sendTab.SubjectField:getValue() ~= nil then
			sendTab.SubjectField:select()
		elseif tonumber(code) == 9 then
			sendTab.SubjectField.element.textfield:SetKeyFocus(true)
		else
			if (sendTab.ToField.element.textfield:GetText() ~= (nil or "")) and (sendTab.SubjectField.element.textfield:GetText() ~= (nil or "")) then
				sendTab.btnSend:SetEnabled(true)
			else
				sendTab.btnSend:SetEnabled(false)
			end
		end
	end
	
	function sendTab.SubjectField.element.textfield.Event:KeyDown(key)
		local code = string.byte(key)
		if tonumber(code) == 9 and sendTab.SentMoneyPlat:getValue() ~= nil then
			sendTab.SentMoneyPlat:select()
		elseif tonumber(code) == 9 then
			sendTab.SentMoneyPlat.element.textfield:SetKeyFocus(true)
		else
			if (sendTab.ToField.element.textfield:GetText() ~= (nil or "")) and (sendTab.SubjectField.element.textfield:GetText() ~= (nil or "")) then
				sendTab.btnSend:SetEnabled(true)
			else
				sendTab.btnSend:SetEnabled(false)
			end
		end
	end
	
	function sendTab.SentMoneySilver.element.textfield.Event:KeyDown(key)
		local code = string.byte(key)
		if tonumber(code) == 9 and sendTab.SentMoneyPlat:getValue() ~= nil then
			sendTab.SentMoneyPlat:select()
		elseif tonumber(code) == 9 then
			sendTab.SentMoneyPlat.element.textfield:SetKeyFocus(true)
		end
		if not sendTab.SubjectField:getValue(true) then
			sendTab.SubjectField:setValue((sendTab.SentMoneyPlat:getValue(true) or 0) .. " platinum " .. (sendTab.SentMoneyGold:getValue(true) or 0) .. " gold " .. (sendTab.SentMoneySilver:getValue(true) or 0) .. " silver")
		end
		if (sendTab.ToField.element.textfield:GetText() ~= (nil or "")) and (sendTab.SubjectField.element.textfield:GetText() ~= (nil or "")) then
			sendTab.btnSend:SetEnabled(true)
		else
			sendTab.btnSend:SetEnabled(false)
		end
	end
	
	function sendTab.SentMoneyGold.element.textfield.Event:KeyDown(key)
		local code = string.byte(key)
		if tonumber(code) == 9 and sendTab.SentMoneySilver:getValue() ~= nil then
			sendTab.SentMoneySilver:select()
		elseif tonumber(code) == 9 then
			sendTab.SentMoneySilver.element.textfield:SetKeyFocus(true)
		end
	end
	
	function sendTab.SentMoneyPlat.element.textfield.Event:KeyDown(key)
		local code = string.byte(key)
		if tonumber(code) == 9 and sendTab.SentMoneyGold:getValue() ~= nil then
			sendTab.SentMoneyGold:select()
		elseif tonumber(code) == 9 then
			sendTab.SentMoneyGold.element.textfield:SetKeyFocus(true)
		end
	end
	
	function sendTab.ToField.element.textfield.Event.KeyFocusLoss()
		if sendTab:GetVisible() == false then
			sendTab.ToField.element.textfield:SetText("")
		else
			if (sendTab.ToField.element.textfield:GetText() ~= (nil or "")) and (sendTab.SubjectField.element.textfield:GetText() ~= (nil or "")) then
				sendTab.btnSend:SetEnabled(true)
			else
				sendTab.btnSend:SetEnabled(false)
			end
		end
	end
	
	function sendTab.SubjectField.element.textfield.Event.KeyFocusLoss()
		if sendTab:GetVisible() == false then
			sendTab.SubjectField.element.textfield:SetText("")
		else
			if (sendTab.ToField.element.textfield:GetText() ~= (nil or "")) and (sendTab.SubjectField.element.textfield:GetText() ~= (nil or "")) then
				sendTab.btnSend:SetEnabled(true)
			else
				sendTab.btnSend:SetEnabled(false)
			end
		end
	end
	
	function sendTab.ToField.element.textfield.Event.TextfieldChange()
		if (sendTab.ToField.element.textfield:GetText() ~= (nil or "")) and (sendTab.SubjectField.element.textfield:GetText() ~= (nil or "")) then
			sendTab.btnSend:SetEnabled(true)
		else
			sendTab.btnSend:SetEnabled(false)
		end
	end
	
	function sendTab.SubjectField.element.textfield.Event.TextfieldChange()
		if (sendTab.ToField.element.textfield:GetText() ~= (nil or "")) and (sendTab.SubjectField.element.textfield:GetText() ~= (nil or "")) then
			sendTab.btnSend:SetEnabled(true)
		else
			sendTab.btnSend:SetEnabled(false)
		end
	end
	
	function sendTab.MessageField.Event:KeyFocusLoss()
		if sendTab:GetVisible() == false then
			sendTab.MessageField:SetText("")
		end
	end
	
	function sendTab.SentMoneySilver.element.textfield.Event.KeyFocusLoss()
		if sendTab:GetVisible() == false then
			sendTab.SentMoneySilver.element.textfield:SetText("")
		else
			if (sendTab.ToField.element.textfield:GetText() ~= (nil or "")) and (sendTab.SubjectField.element.textfield:GetText() ~= (nil or "")) then
				sendTab.btnSend:SetEnabled(true)
			else
				sendTab.btnSend:SetEnabled(false)
			end
		end
	end
	
	function sendTab.SentMoneyGold.element.textfield.Event.KeyFocusLoss()
		if sendTab:GetVisible() == false then
			sendTab.SentMoneyGold.element.textfield:SetText("")
		else
			if (sendTab.ToField.element.textfield:GetText() ~= (nil or "")) and (sendTab.SubjectField.element.textfield:GetText() ~= (nil or "")) then
				sendTab.btnSend:SetEnabled(true)
			else
				sendTab.btnSend:SetEnabled(false)
			end
		end
	end
		
	function sendTab.SentMoneyPlat.element.textfield.Event.KeyFocusLoss()
		if sendTab:GetVisible() == false then
			sendTab.SentMoneyPlat.element.textfield:SetText("")
		else
			if (sendTab.ToField.element.textfield:GetText() ~= (nil or "")) and (sendTab.SubjectField.element.textfield:GetText() ~= (nil or "")) then
				sendTab.btnSend:SetEnabled(true)
			else
				sendTab.btnSend:SetEnabled(false)
			end
		end
	end
	
	function sendTab.btnSend.Event:LeftPress()
		EM.UI.Send.Recipients = {}
		if string.find(sendTab.ToField:getValue(true), "; ") then
			for word in string.gmatch(sendTab.ToField:getValue(true), "%a+") do
				table.insert(EM.UI.Send.Recipients, word)
			end
		else
			table.insert(EM.UI.Send.Recipients, sendTab.ToField:getValue(true))
		end
		EM.Event.Trigger.SendMessage()
	end
	
	EM.UI.Send.AttachGrid = sendTab.AttachGrid
	
	sendTab.AttachGrid:setClickEvent(EM.UI.attachGridRightClick, true)
	
end

function EM.UI.SendAttach()
	
	if EM.Temp.PopupTest then
		EM.UI.SendMessage()
		EM.Temp.PopupTest = false
	else
		EM.UI.Popup(2, "Send next set of attachments?", EM.UI.SendAttach)
	end

end

function EM.UI.SendMultiRecipients()

	if EM.Temp.PopupTest then
		EM.UI.SendMessage()
		EM.Temp.PopupTest = false
	else
		EM.UI.Popup(2, "Send message to " .. EM.UI.Send.Recipients[1] .. "?", EM.UI.SendMultiRecipients)
	end

end

function EM.UI.Send.UpdateCurrency(currencies)
	if currencies.coin and (EM.UI.MailWindow and EM.UI.MailWindow:GetVisible() and EM.UI.Tabs:getActivePane() == 2) then
		local plat,gold,silver = EM.Utility.Coin(currencies.coin)
		EM.UI.Send.element.YourMoneyPlat:update{text = plat}
		EM.UI.Send.element.YourMoneyGold:update{text = gold}
		EM.UI.Send.element.YourMoneySilver:update{text = silver}
	end
end

function EM.UI.attachGridRightClick(row)

	local sendTab = EM.UI.Send:getElement()
	
	if not EM.UI.Send.AttachGrid.values then return end
	if not EM.UI.Send.AttachGrid.values[row] then return end
	local realRow = (row - 1 + EM.UI.Send.AttachGrid.counter)
	local counter = EM.UI.Send.AttachGrid.counter
	
	if EM.UI.Send.Attachments[realRow][1].slot then
		local bag = EM.UI.Send.Attachments[realRow][1].slot[1]
		local slot = EM.UI.Send.Attachments[realRow][1].slot[2]
		EM.UI.Inventory.Bags[bag][slot]:SetBackgroundColor(0,0,0,0)
		EM.UI.Inventory.Bags[bag][slot].attached = false
	end
	
	table.remove(EM.UI.Send.Attachments, realRow)
	if counter > 1 then
		counter = counter - 1
	else
		counter = 1
	end
	if sendTab.radioButtonGroup:GetSelectedIndex() == 2 and #EM.UI.Send.Attachments == 0 then
		sendTab.SendMoneyRadio:SetSelected(true, true)
	end
	sendTab.AttachScrollBar:SetPosition(counter)
	EM.UI.Send.AttachGrid:fill(EM.UI.Send.Attachments)

end

EM.Temp.mail = {}	
	
function EM.UI.SendMessage()
	local codValue = nil
	local coinValue = nil
	local attachment = EM.Utility.AttachSetup()
		
	local sendTab = EM.UI.Send:getElement()
	
	local tofield,multipleRecipients = EM.Utility.RecipientSetup()

	if multipleRecipients then
			EM.Temp.mail = { 	to = tofield, subject = sendTab.SubjectField:getValue(true),
						body = sendTab.MessageField:GetText() }
	else
		if sendTab.radioButtonGroup:GetSelectedIndex() == 1 then
			coinValue = ((sendTab.SentMoneyPlat:getValue(false) or 0) * 10000) + ((sendTab.SentMoneyGold:getValue(false) or 0) * 100) + (sendTab.SentMoneySilver:getValue(false) or 0)
			EM.Temp.mail = { 	to = tofield, subject = sendTab.SubjectField:getValue(true),
						body = sendTab.MessageField:GetText(), coin = coinValue, attachments = attachment }
		elseif sendTab.radioButtonGroup:GetSelectedIndex() == 2 then
			codValue = ((sendTab.SentMoneyPlat:getValue(false) or 0) * 10000) + ((sendTab.SentMoneyGold:getValue(false) or 0) * 100) + (sendTab.SentMoneySilver:getValue(false) or 0)
			EM.Temp.mail = { 	to = tofield, subject = sendTab.SubjectField:getValue(true),
						body = sendTab.MessageField:GetText(), cod = codValue, attachments = attachment }
		end
	end
	Command.Mail.Send(EM.Temp.mail, EM.UI.Callback.Send)
end
	
function EM.UI.Callback.Send(status, message)
	if EasyMailTable[EM.PlayerName].SentCount then
		EasyMailTable[EM.PlayerName].SentCount = EasyMailTable[EM.PlayerName].SentCount + 1
		repeat
			EasyMailTable[EM.PlayerName].SentCount = "0" .. EasyMailTable[EM.PlayerName].SentCount
		until string.len(EasyMailTable[EM.PlayerName].SentCount) == 12
	else
		EasyMailTable[EM.PlayerName].SentCount = "000000000001"
	end
	if not status then
		local sentMail = EM.Temp.mail
		local id = "m454d" .. EasyMailTable[EM.PlayerName].SentCount
		local sendtime = os.date("%x %X", Inspect.Time.Server())
		sentMail["timesent"] = sendtime
		sentMail["id"] = id
		if sentMail["attachments"] then
			sentMail["attachmentCount"] = #sentMail["attachments"]
		end
		EasyMailTable[EM.PlayerName].Sent[id] = sentMail
	else
		if message then
			print(message)
		end
	end
	if #EM.UI.Send.Attachments > 0 then
		EM.Event.Trigger.SendAttach()
	elseif #EM.UI.Send.Recipients > 0 then
		EM.Event.Trigger.SendMultiRecipients()
	else
		EM.Utility.ClearMessage()
	end
end

table.insert(Event.Currency,				{ EM.UI.Send.UpdateCurrency, AddonId, AddonId .. "_UpdateCurrency" })
table.insert(EM.Event.SendMessage,			{ EM.UI.SendMessage, AddonId, AddonId .. "_SendMessage" })
table.insert(EM.Event.SendAttach,			{ EM.UI.SendAttach, AddonId, AddonId .. "_SendAttach" })
table.insert(EM.Event.SendMultiRecipients,	{ EM.UI.SendMultiRecipients, AddonId, AddonId .. "_SendMultiRecipients" })